/****************************************************************************
*                                                                           *
* Copyright 2004-2011 LSI Corporation. All rights reserved. This file is    *
* confidential and a trade secret of LSI Corporation. The receipt or        *
* possession of this file does not convey any rights to reproduce or        *
* disclose its contents or to manufacture, use, or sell anything it may     *
* describe, in whole, or in part, without the specific written consent of   *
* LSI Corporation.                                                          *
*                                                                           *
****************************************************************************/
/****************************************************************************
*                                                                           *
* NAME            mem_space.c                                               *
* SUMMARY                                                                   *
* VERSION         %version: %                                               *
* UPDATE DATE     %date_modified: %                                         *
* PROGRAMMER      %created_by:    Shawn Wang %                              *
*                                                                           *
*        Copyright 2002-2011 LSI Corporation. All Rights Reserved.          *
*                                                                           *
* DESCRIPTION:                                                              *
*                                                                           *
****************************************************************************/

#include <linux/init.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include "mem_space.h"

/***  GLOBAL DATA  ***/
unsigned long gDiagAvailAddr;
/*** EXPORT_SYMBOL ***/
EXPORT_SYMBOL(gDiagAvailAddr);


/***  PROCEDURES  ***/
/*******************************************************************************
* PROCEDURE
*
* NAME:     pikespeakGetKernelMemory
* SUMMARY:  This procedure will test the ability of the Crystal Beach DMA devices to 
*                       gernerate parity
* SCOPE:    public
*
* DESCRIPTION:  This test will trigger each Crystal Beach DMA device 
*                               to generate parity of 8 memory blocks  
*                               and verify the parity by processor.
*
* RETURNS:
*
* NOTES:
*
*/
void diagGetKernelMemory(void)
{
	//gDiagAvailAddr = (UINT64)(num_physpages << PAGE_SHIFT);
	gDiagAvailAddr = 0x20000000ULL;	// Start from 512MB
}
