#ifndef USB_DAPI_H
#define USB_DAPI_H

#include "BaseClassDAPI.hpp"
#include "USBDDAPI.hpp"
#include "MemoryDAPI.hpp"




class USBDAPI : public BaseClassDAPI
{
    public: 
                         USBDAPI(STRING className);
            virtual      ~USBDAPI(void);
            ErrorMsg*   displayUSBDevicesList(list<string> *pUSBList);
            ErrorMsg*   getLogicalIdByName(STRING WellKnownName, UINT32 *LogicalID);




            ErrorMsg*   getDataByID(UINT32 LogicalID,
                                    USB_DATA_ELEMENT USBDataElement,
                                    list<string> *returnDataInfo);



            //Read/Write Performance
            ErrorMsg*   readwriteTest(UINT32 LogicalID,
                                      list<string> *returnDataInfo,
                                      UINT32 StartSector,
                                      UINT32 TestSize = DEFAULT_USB_TEST_SIZE,
                                      UINT32  BlockSize = DEFAULT_USB_BLOCK_SIZE);
            ErrorMsg*   readwriteTestSetup(UINT32   LogicalID,
                                           UINT32   LogicalSector,
                                           UINT32   TestSize = DEFAULT_USB_TEST_SIZE,
                                           UINT32   BlockSize = DEFAULT_USB_BLOCK_SIZE);
            ErrorMsg*   readwriteTestExecute(UINT32   LogicalID,
                                             list<string> *returnDataInfo,
                                             UINT32   LogicalSector,
                                             UINT32   TestSize = DEFAULT_USB_TEST_SIZE,
                                             UINT32  BlockSize = DEFAULT_USB_BLOCK_SIZE);
            ErrorMsg*   readwriteTestCleanup(UINT32 LogicalID);


            //Read Performance
            ErrorMsg*   readPerformanceTest(UINT32  LogicalID,
                                            list<string> *returnDataInfo,
                                            UINT32  StartSector,
                                            UINT32 TestSize = DEFAULT_USB_TEST_SIZE,
                                            UINT32  BlockSize = DEFAULT_USB_BLOCK_SIZE);
            ErrorMsg*   readPerformanceTestSetup(UINT32 LogicalID,
                                                 UINT32 LogicalSector,
                                                 UINT32 TestSize = DEFAULT_USB_TEST_SIZE,
                                                 UINT32  BlockSize = DEFAULT_USB_BLOCK_SIZE);
            ErrorMsg*   readPerformanceTestExecute(UINT32   LogicalID,
                                                   list<string> *returnDataInfo,
                                                   UINT32   LogicalSector,
                                                   UINT32 TestSize = DEFAULT_USB_TEST_SIZE,
                                                   UINT32  BlockSize = DEFAULT_USB_BLOCK_SIZE);
            ErrorMsg*   readPerformanceTestCleanup(UINT32 LogicalID);


            //Write Performance
            ErrorMsg*   writePerformanceTest(UINT32 LogicalID,
                                             list<string> *returnDataInfo,
                                             UINT32 StartSector,
                                             UINT32 TestSize = DEFAULT_USB_TEST_SIZE,
                                             UINT32  BlockSize = DEFAULT_USB_BLOCK_SIZE);
            ErrorMsg*   writePerformanceTestSetup(UINT32   LogicalID,
                                                  UINT32   LogicalSector,
                                                  UINT32 TestSize = DEFAULT_USB_TEST_SIZE,
                                                  UINT32  BlockSize = DEFAULT_USB_BLOCK_SIZE);
            ErrorMsg*   writePerformanceTestExecute(UINT32   LogicalID,
                                                    list<string> *returnDataInfo,
                                                    UINT32   LogicalSector,
                                                    UINT32 TestSize = DEFAULT_USB_TEST_SIZE,
                                                    UINT32  BlockSize = DEFAULT_USB_BLOCK_SIZE);
            ErrorMsg*   writePerformanceTestCleanup(UINT32 LogicalID);
    private:
            USBDDAPI    *m_USBDiver;
            MemoryDAPI  *m_pMemoryDAPI;
            UINT32      *m_pDataBuffer;

            //FILE*       m_pFileHandle;
            INT32      m_pFileHandle;

            ErrorMsg    *m_errorCode;

            ErrorMsg*   openDeviceFile(STRING intFileNode);
            ErrorMsg*   closeDeviceFile(UINT32 in_pFileNode);
            //ErrorMsg*   SetFileDescription(INT32 fileDescription);






};

#endif
