#ifndef BBUBaseClassDDAPI_H
#define BBUBaseClassDDAPI_H

#include "BaseClassDDAPI.hpp"

/*enum bbu_type{
  BBU_I2C,
};*/



#define ManufacturerAccess     0x00
#define RemainingCapacityAlarm 0x01
#define RemainingTimeAlarm     0x02
#define BatteryMode            0x03
#define AtRate                 0x04
#define AtRateTimeToFull       0x05
#define AtRateTimeToEmpty      0x06
#define AtRateOK               0x07
#define Temperature            0x08
#define Voltage                0x09
#define Current                0x0a
#define AverageCurrent         0x0b
#define MaxError               0x0c
#define RelativeStateOfCharge  0x0d
#define AbsoluteStateOfCharge  0x0e
#define RemainingCapacity      0x0f
#define FullChargeCapacity     0x10
#define RunTimeToEmpty         0x11
#define AverageTimeToEmpty     0x12
#define AverageTimeToFull      0x13
#define ChargingCurrent        0x14
#define ChargingVoltage        0x15
#define BatteryStatus          0x16
#define CycleCount             0x17
#define DesignCapacity         0x18
#define DesignVoltage          0x19
#define SpecificationInfo      0x1a
#define ManufactureDate        0x1b
#define SerialNumber           0x1c
#define ManufacturerName       0x20
#define DeviceName             0x21
#define DeviceChemistry        0x22
#define ManufacturerData       0x23



class BBUBaseClassDDAPI : public BaseClassDDAPI
{
    public:
                       BBUBaseClassDDAPI();
                       ~BBUBaseClassDDAPI();

     virtual string    Get_name(); // Get the BBU name on system:bbu0, bbu1 ...
     virtual ErrorMsg* Get_Temperature(float *temperature);
     virtual ErrorMsg* Get_Current(int *current);
     virtual ErrorMsg* Get_Max_Error(int *max_error);
     virtual ErrorMsg* Get_Charger_System_State(int *cs_state);
     virtual ErrorMsg* Get_FW_BBU_State(int *fw_bbu_state);
     virtual ErrorMsg* Get_Voltage(int *voltage);
     virtual ErrorMsg* Get_Charging_Current(int *charging_current);
     virtual ErrorMsg* Get_Gas_Gauge_Stat(int *gas_gauge_stat);
     virtual ErrorMsg* Get_Charger_Sys_Control(int *charger_sys_control);
     virtual ErrorMsg* Get_Relative_State_Charge(int *relative_state_charge);
     virtual ErrorMsg* Get_Absolute_State_Charge(int *absolute_state_charge);
     virtual ErrorMsg* Get_Remaining_Capacity(int *remaining_Capacity);
     virtual ErrorMsg* Get_Full_Charge_Capacity(int *full_charge_capacity);
     virtual ErrorMsg* Get_Time_Empty(int *time_empty);
     virtual ErrorMsg* Get_Average_Time_Empty(int *average_time_empty);
     virtual ErrorMsg* Get_Average_Time_Full(int *average_time_full);
     virtual ErrorMsg* Get_Cycle_Count(int *cycle_Count);
     virtual ErrorMsg* Get_Design_Capacity(int *design_capacity);
     virtual ErrorMsg* Get_Design_Voltage(int *design_voltage);
     virtual ErrorMsg* Get_Specification_Info(int *specification_info);
     virtual ErrorMsg* Get_Date_Manufacture(string *date_manufacture);
     virtual ErrorMsg* Get_Serial_Number(int *serial_Number);
     virtual ErrorMsg* Get_Pack_Status_Config(int *pack_status_config);
     virtual ErrorMsg* Get_Manufacturer_Name(string *manufacturer_name);
     virtual ErrorMsg* Get_Device_name(string *device_name);
     virtual ErrorMsg* Get_Device_Chemistry(string *device_chemistry);
     virtual ErrorMsg* Get_Design_Data(string *design_data);

     virtual ErrorMsg* Read(string name,int start_address, int end_address, int *data, int *count);
     virtual ErrorMsg* Write(string name, int address, int *data, int count, int *numberRealWrite);
//     virtual ErrorMsg* Monitor(string name, int time = 0);
     virtual ErrorMsg* Charge();
     virtual ErrorMsg* Discharge();

     virtual ErrorMsg* ShowChargeStatus(int *status);

     virtual ErrorMsg* Set_name(string name);
     virtual ErrorMsg* Set_Temperature(float temperature);
     virtual ErrorMsg* Set_Current(int current);
     virtual ErrorMsg* Set_Max_Error(int max_error);
     virtual ErrorMsg* Set_Charger_System_State(int cs_state);
     virtual ErrorMsg* Set_FW_BBU_State(int fw_bbu_state);
     virtual ErrorMsg* Set_Voltage(float voltage);
     virtual ErrorMsg* Set_Charging_Current(int charging_current);
     virtual ErrorMsg* Set_Gas_Gauge_Stat(int gas_gauge_stat);
     virtual ErrorMsg* Set_Charger_Sys_Control(int charger_sys_control);
     virtual ErrorMsg* Set_Relative_State_Charge(int relative_state_charge);
     virtual ErrorMsg* Set_Absolute_State_Charge(int absolute_state_charge);
     virtual ErrorMsg* Set_Remaining_Capacity(int remaining_Capacity);
     virtual ErrorMsg* Set_Full_Charge_Capacity(int full_charge_capacity);
     virtual ErrorMsg* Set_Time_Empty(int time_empty);
     virtual ErrorMsg* Set_Average_Time_Empty(int average_time_empty);
     virtual ErrorMsg* Set_Average_Time_Full(int average_time_full);
     virtual ErrorMsg* Set_Cycle_Count(int cycle_Count);
     virtual ErrorMsg* Set_Design_Capacity(int design_capacity);
     virtual ErrorMsg* Set_Design_Voltage(int design_voltage);
     virtual ErrorMsg* Set_Specification_Info(int specification_info);
     virtual ErrorMsg* Set_Date_Manufacture(string date_manufacture);
     virtual ErrorMsg* Set_Serial_Number(string serial_Number);
     virtual ErrorMsg* Set_Pack_Status_Config(int pack_status_config);
     virtual ErrorMsg* Set_Manufacturer_Name(string manufacturer_name);
     virtual ErrorMsg* Set_Device_name(string device_name);
     virtual ErrorMsg* Set_Device_Chemistry(string device_chemistry);
     virtual ErrorMsg* Set_Design_Data(string design_data);

    protected:

    private:
               string  name;
               /*float   temperature;
               int     current;
               int     max_error;
               int     cs_state;

               float  current_temperature;
               float  threshold_hight;
               float  threshold_low;
               temperature_type    type;*/
};

#endif
