#ifndef BBU_I2C_TI_bq40z50_H
#define BBU_I2C_TI_bq40z50_H

#include "BBUBaseClassDDAPI.hpp"
#include "I2CDDAPI.hpp"
#include "PCIDDAPI.hpp"
#include "MemoryDDAPI.hpp"

class BBU_I2C_TI_bq40z50 : public BBUBaseClassDDAPI
{
    public:
                       BBU_I2C_TI_bq40z50();
                       ~BBU_I2C_TI_bq40z50();

//   virtual ERRORCODE Get_name(string *name);
     virtual ErrorMsg* Get_Temperature(float *temperature);
     virtual ErrorMsg* Get_Current(int *current);
     virtual ErrorMsg* Get_Max_Error(int *max_error);
     virtual ErrorMsg* Get_Charger_System_State(int *cs_state);
     virtual ErrorMsg* Get_FW_BBU_State(int *fw_bbu_state);
     virtual ErrorMsg* Get_Voltage(int *voltage);
     virtual ErrorMsg* Get_Charging_Current(int *charging_current);
     virtual ErrorMsg* Get_Gas_Gauge_Stat(int *gas_gauge_stat);
     virtual ErrorMsg* Get_Charger_Sys_Control(int *charger_sys_control);
     virtual ErrorMsg* Get_Relative_State_Charge(int *relative_state_charge);
     virtual ErrorMsg* Get_Absolute_State_Charge(int *absolute_state_charge);
     virtual ErrorMsg* Get_Remaining_Capacity(int *remaining_Capacity);
     virtual ErrorMsg* Get_Full_Charge_Capacity(int *full_charge_capacity);
     virtual ErrorMsg* Get_Time_Empty(int *time_empty);
     virtual ErrorMsg* Get_Average_Time_Empty(int *average_time_empty);
     virtual ErrorMsg* Get_Average_Time_Full(int *average_time_full);
     virtual ErrorMsg* Get_Cycle_Count(int *cycle_Count);
     virtual ErrorMsg* Get_Design_Capacity(int *design_capacity);
     virtual ErrorMsg* Get_Design_Voltage(int *design_voltage);
     virtual ErrorMsg* Get_Specification_Info(int *specification_info);
     virtual ErrorMsg* Get_Date_Manufacture(string *date_manufacture);
     virtual ErrorMsg* Get_Serial_Number(int *serial_Number);
     virtual ErrorMsg* Get_Pack_Status_Config(int *pack_status_config);
     virtual ErrorMsg* Get_Manufacturer_Name(string *manufacturer_name);
     virtual ErrorMsg* Get_Device_name(string *device_name);
     virtual ErrorMsg* Get_Device_Chemistry(string *device_chemistry);
     virtual ErrorMsg* Get_Design_Data(string *design_data);

     virtual ErrorMsg* Read(string name,int start_address, int end_address, int *data, int *count);
     virtual ErrorMsg* Write(string name, int address, int *data, int count, int *numberRealWrite);

     virtual ErrorMsg* Charge();
     virtual ErrorMsg* Discharge();

     virtual ErrorMsg* ShowChargeStatus(int *status);

//   virtual ERRORCODE Set_name(string name);
     virtual ErrorMsg* Set_Temperature(float temperature);
     virtual ErrorMsg* Set_Current(int current);
     virtual ErrorMsg* Set_Max_Error(int max_error);
     virtual ErrorMsg* Set_Charger_System_State(int cs_state);
     virtual ErrorMsg* Set_FW_BBU_State(int fw_bbu_state);
     virtual ErrorMsg* Set_Voltage(float voltage);
     virtual ErrorMsg* Set_Charging_Current(int charging_current);
     virtual ErrorMsg* Set_Gas_Gauge_Stat(int gas_gauge_stat);
     virtual ErrorMsg* Set_Charger_Sys_Control(int charger_sys_control);
     virtual ErrorMsg* Set_Relative_State_Charge(int relative_state_charge);
     virtual ErrorMsg* Set_Absolute_State_Charge(int absolute_state_charge);
     virtual ErrorMsg* Set_Remaining_Capacity(int remaining_Capacity);
     virtual ErrorMsg* Set_Full_Charge_Capacity(int full_charge_capacity);
     virtual ErrorMsg* Set_Time_Empty(int time_empty);
     virtual ErrorMsg* Set_Average_Time_Empty(int average_time_empty);
     virtual ErrorMsg* Set_Average_Time_Full(int average_time_full);
     virtual ErrorMsg* Set_Cycle_Count(int cycle_Count);
     virtual ErrorMsg* Set_Design_Capacity(int design_capacity);
     virtual ErrorMsg* Set_Design_Voltage(int design_voltage);
     virtual ErrorMsg* Set_Specification_Info(int specification_info);
     virtual ErrorMsg* Set_Date_Manufacture(string date_manufacture);
     virtual ErrorMsg* Set_Serial_Number(string serial_Number);
     virtual ErrorMsg* Set_Pack_Status_Config(int pack_status_config);
     virtual ErrorMsg* Set_Manufacturer_Name(string manufacturer_name);
     virtual ErrorMsg* Set_Device_name(string device_name);
     virtual ErrorMsg* Set_Device_Chemistry(string device_chemistry);
     virtual ErrorMsg* Set_Design_Data(string design_data);


    protected:

    private:
             ErrorMsg  *m_pErrorMsg;
};

#endif
